/**
 * <copyright>
 * THALES MARTE TO RAPIDRMA (Copyright (c) THALES 2008 All rights reserved) is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html 
 *  
 * THALES MARTE TO RAPIDRMA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 *
 * </copyright>
 *
 * $Id: DeadlineKind.java,v 1.2 2008/06/16 13:56:07 sdemathieu Exp $
 */
package com.thalesgroup.marte.rapidrma.task;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Deadline Kind</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getDeadlineKind()
 * @model
 * @generated
 */
public final class DeadlineKind extends AbstractEnumerator {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright 2007 Thales Research & Technology";

	/**
	 * The '<em><b>Hard Deadline</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Hard Deadline</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HARD_DEADLINE_LITERAL
	 * @model name="HardDeadline"
	 * @generated
	 * @ordered
	 */
	public static final int HARD_DEADLINE = 0;

	/**
	 * The '<em><b>Soft Deadline</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Soft Deadline</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SOFT_DEADLINE_LITERAL
	 * @model name="SoftDeadline"
	 * @generated
	 * @ordered
	 */
	public static final int SOFT_DEADLINE = 1;

	/**
	 * The '<em><b>No Deadline</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>No Deadline</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_DEADLINE_LITERAL
	 * @model name="NoDeadline"
	 * @generated
	 * @ordered
	 */
	public static final int NO_DEADLINE = 2;

	/**
	 * The '<em><b>Hard Deadline</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HARD_DEADLINE
	 * @generated
	 * @ordered
	 */
	public static final DeadlineKind HARD_DEADLINE_LITERAL = new DeadlineKind(HARD_DEADLINE, "HardDeadline", "HardDeadline");

	/**
	 * The '<em><b>Soft Deadline</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SOFT_DEADLINE
	 * @generated
	 * @ordered
	 */
	public static final DeadlineKind SOFT_DEADLINE_LITERAL = new DeadlineKind(SOFT_DEADLINE, "SoftDeadline", "SoftDeadline");

	/**
	 * The '<em><b>No Deadline</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_DEADLINE
	 * @generated
	 * @ordered
	 */
	public static final DeadlineKind NO_DEADLINE_LITERAL = new DeadlineKind(NO_DEADLINE, "NoDeadline", "NoDeadline");

	/**
	 * An array of all the '<em><b>Deadline Kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final DeadlineKind[] VALUES_ARRAY =
		new DeadlineKind[] {
			HARD_DEADLINE_LITERAL,
			SOFT_DEADLINE_LITERAL,
			NO_DEADLINE_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Deadline Kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Deadline Kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DeadlineKind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DeadlineKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Deadline Kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DeadlineKind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DeadlineKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Deadline Kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DeadlineKind get(int value) {
		switch (value) {
			case HARD_DEADLINE: return HARD_DEADLINE_LITERAL;
			case SOFT_DEADLINE: return SOFT_DEADLINE_LITERAL;
			case NO_DEADLINE: return NO_DEADLINE_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private DeadlineKind(int value, String name, String literal) {
		super(value, name, literal);
	}

} //DeadlineKind
