/**
 * <copyright>
 * THALES MARTE TO RAPIDRMA (Copyright (c) THALES 2008 All rights reserved) is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html 
 *  
 * THALES MARTE TO RAPIDRMA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 *
 * </copyright>
 *
 * $Id: IntermediateDeadline.java,v 1.2 2008/06/16 13:56:07 sdemathieu Exp $
 */
package com.thalesgroup.marte.rapidrma.task;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Intermediate Deadline</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.IntermediateDeadline#getWorkRemaining <em>Work Remaining</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.IntermediateDeadline#getStartTime <em>Start Time</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.IntermediateDeadline#getEndTime <em>End Time</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.IntermediateDeadline#getIntDeadline <em>Int Deadline</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getIntermediateDeadline()
 * @model
 * @generated
 */
public interface IntermediateDeadline extends EObject {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright 2007 Thales Research & Technology";

	/**
	 * Returns the value of the '<em><b>Work Remaining</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Work Remaining</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Work Remaining</em>' attribute.
	 * @see #setWorkRemaining(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getIntermediateDeadline_WorkRemaining()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getWorkRemaining();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.IntermediateDeadline#getWorkRemaining <em>Work Remaining</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Work Remaining</em>' attribute.
	 * @see #getWorkRemaining()
	 * @generated
	 */
	void setWorkRemaining(int value);

	/**
	 * Returns the value of the '<em><b>Start Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Time</em>' attribute.
	 * @see #setStartTime(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getIntermediateDeadline_StartTime()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getStartTime();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.IntermediateDeadline#getStartTime <em>Start Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Time</em>' attribute.
	 * @see #getStartTime()
	 * @generated
	 */
	void setStartTime(int value);

	/**
	 * Returns the value of the '<em><b>End Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>End Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>End Time</em>' attribute.
	 * @see #setEndTime(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getIntermediateDeadline_EndTime()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getEndTime();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.IntermediateDeadline#getEndTime <em>End Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>End Time</em>' attribute.
	 * @see #getEndTime()
	 * @generated
	 */
	void setEndTime(int value);

	/**
	 * Returns the value of the '<em><b>Int Deadline</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Int Deadline</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Int Deadline</em>' attribute.
	 * @see #setIntDeadline(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getIntermediateDeadline_IntDeadline()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getIntDeadline();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.IntermediateDeadline#getIntDeadline <em>Int Deadline</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Int Deadline</em>' attribute.
	 * @see #getIntDeadline()
	 * @generated
	 */
	void setIntDeadline(int value);

} // IntermediateDeadline