/**
 * <copyright>
 * THALES MARTE TO RAPIDRMA (Copyright (c) THALES 2008 All rights reserved) is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html 
 *  
 * THALES MARTE TO RAPIDRMA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 *
 * </copyright>
 *
 * $Id: PeriodicServer.java,v 1.2 2008/06/16 13:56:07 sdemathieu Exp $
 */
package com.thalesgroup.marte.rapidrma.task;

import com.thalesgroup.marte.rapidrma.resource.Resource;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Periodic Server</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getName <em>Name</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getPeriod <em>Period</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getBudget <em>Budget</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getRelDeadline <em>Rel Deadline</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getPhase <em>Phase</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getPriority <em>Priority</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getActiveResource <em>Active Resource</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getType <em>Type</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getQueueing <em>Queueing</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer()
 * @model
 * @generated
 */
public interface PeriodicServer extends EObject {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright 2007 Thales Research & Technology";

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer_Name()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Period</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Period</em>' attribute.
	 * @see #setPeriod(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer_Period()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getPeriod();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getPeriod <em>Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Period</em>' attribute.
	 * @see #getPeriod()
	 * @generated
	 */
	void setPeriod(int value);

	/**
	 * Returns the value of the '<em><b>Budget</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Budget</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Budget</em>' attribute.
	 * @see #setBudget(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer_Budget()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getBudget();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getBudget <em>Budget</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Budget</em>' attribute.
	 * @see #getBudget()
	 * @generated
	 */
	void setBudget(int value);

	/**
	 * Returns the value of the '<em><b>Rel Deadline</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rel Deadline</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rel Deadline</em>' attribute.
	 * @see #setRelDeadline(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer_RelDeadline()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getRelDeadline();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getRelDeadline <em>Rel Deadline</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rel Deadline</em>' attribute.
	 * @see #getRelDeadline()
	 * @generated
	 */
	void setRelDeadline(int value);

	/**
	 * Returns the value of the '<em><b>Phase</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Phase</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Phase</em>' attribute.
	 * @see #setPhase(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer_Phase()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getPhase();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getPhase <em>Phase</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Phase</em>' attribute.
	 * @see #getPhase()
	 * @generated
	 */
	void setPhase(int value);

	/**
	 * Returns the value of the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Priority</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Priority</em>' attribute.
	 * @see #setPriority(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer_Priority()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getPriority();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getPriority <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Priority</em>' attribute.
	 * @see #getPriority()
	 * @generated
	 */
	void setPriority(int value);

	/**
	 * Returns the value of the '<em><b>Active Resource</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Active Resource</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Active Resource</em>' reference.
	 * @see #setActiveResource(Resource)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer_ActiveResource()
	 * @model ordered="false"
	 * @generated
	 */
	Resource getActiveResource();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getActiveResource <em>Active Resource</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Active Resource</em>' reference.
	 * @see #getActiveResource()
	 * @generated
	 */
	void setActiveResource(Resource value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The literals are from the enumeration {@link com.thalesgroup.marte.rapidrma.task.ServerKind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.thalesgroup.marte.rapidrma.task.ServerKind
	 * @see #setType(ServerKind)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer_Type()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	ServerKind getType();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.thalesgroup.marte.rapidrma.task.ServerKind
	 * @see #getType()
	 * @generated
	 */
	void setType(ServerKind value);

	/**
	 * Returns the value of the '<em><b>Queueing</b></em>' attribute.
	 * The literals are from the enumeration {@link com.thalesgroup.marte.rapidrma.task.QueueingKind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Queueing</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Queueing</em>' attribute.
	 * @see com.thalesgroup.marte.rapidrma.task.QueueingKind
	 * @see #setQueueing(QueueingKind)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getPeriodicServer_Queueing()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	QueueingKind getQueueing();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.PeriodicServer#getQueueing <em>Queueing</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Queueing</em>' attribute.
	 * @see com.thalesgroup.marte.rapidrma.task.QueueingKind
	 * @see #getQueueing()
	 * @generated
	 */
	void setQueueing(QueueingKind value);

} // PeriodicServer