/**
 * <copyright>
 * THALES MARTE TO RAPIDRMA (Copyright (c) THALES 2008 All rights reserved) is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html 
 *  
 * THALES MARTE TO RAPIDRMA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 *
 * </copyright>
 *
 * $Id: ResourceUsage.java,v 1.2 2008/06/16 13:56:07 sdemathieu Exp $
 */
package com.thalesgroup.marte.rapidrma.task;

import com.thalesgroup.marte.rapidrma.resource.Resource;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Resource Usage</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getResource <em>Resource</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getStartTime <em>Start Time</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getEndTime <em>End Time</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getAcquisitionTime <em>Acquisition Time</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getDeacquisitionTime <em>Deacquisition Time</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getResourceUsage()
 * @model
 * @generated
 */
public interface ResourceUsage extends EObject {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright 2007 Thales Research & Technology";

	/**
	 * Returns the value of the '<em><b>Resource</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resource</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resource</em>' reference.
	 * @see #setResource(Resource)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getResourceUsage_Resource()
	 * @model ordered="false"
	 * @generated
	 */
	Resource getResource();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getResource <em>Resource</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Resource</em>' reference.
	 * @see #getResource()
	 * @generated
	 */
	void setResource(Resource value);

	/**
	 * Returns the value of the '<em><b>Start Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Time</em>' attribute.
	 * @see #setStartTime(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getResourceUsage_StartTime()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getStartTime();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getStartTime <em>Start Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Time</em>' attribute.
	 * @see #getStartTime()
	 * @generated
	 */
	void setStartTime(int value);

	/**
	 * Returns the value of the '<em><b>End Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>End Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>End Time</em>' attribute.
	 * @see #setEndTime(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getResourceUsage_EndTime()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getEndTime();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getEndTime <em>End Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>End Time</em>' attribute.
	 * @see #getEndTime()
	 * @generated
	 */
	void setEndTime(int value);

	/**
	 * Returns the value of the '<em><b>Acquisition Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Acquisition Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Acquisition Time</em>' attribute.
	 * @see #setAcquisitionTime(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getResourceUsage_AcquisitionTime()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getAcquisitionTime();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getAcquisitionTime <em>Acquisition Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Acquisition Time</em>' attribute.
	 * @see #getAcquisitionTime()
	 * @generated
	 */
	void setAcquisitionTime(int value);

	/**
	 * Returns the value of the '<em><b>Deacquisition Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deacquisition Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deacquisition Time</em>' attribute.
	 * @see #setDeacquisitionTime(int)
	 * @see com.thalesgroup.marte.rapidrma.task.TaskPackage#getResourceUsage_DeacquisitionTime()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	int getDeacquisitionTime();

	/**
	 * Sets the value of the '{@link com.thalesgroup.marte.rapidrma.task.ResourceUsage#getDeacquisitionTime <em>Deacquisition Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deacquisition Time</em>' attribute.
	 * @see #getDeacquisitionTime()
	 * @generated
	 */
	void setDeacquisitionTime(int value);

} // ResourceUsage