/**
 * <copyright>
 * THALES MARTE TO RAPIDRMA (Copyright (c) THALES 2008 All rights reserved) is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html 
 *  
 * THALES MARTE TO RAPIDRMA is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 *
 * </copyright>
 *
 * $Id: ResourceUsageImpl.java,v 1.2 2008/06/16 13:56:07 sdemathieu Exp $
 */
package com.thalesgroup.marte.rapidrma.task.impl;

import com.thalesgroup.marte.rapidrma.resource.Resource;

import com.thalesgroup.marte.rapidrma.task.ResourceUsage;
import com.thalesgroup.marte.rapidrma.task.TaskPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Resource Usage</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.impl.ResourceUsageImpl#getResource <em>Resource</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.impl.ResourceUsageImpl#getStartTime <em>Start Time</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.impl.ResourceUsageImpl#getEndTime <em>End Time</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.impl.ResourceUsageImpl#getAcquisitionTime <em>Acquisition Time</em>}</li>
 *   <li>{@link com.thalesgroup.marte.rapidrma.task.impl.ResourceUsageImpl#getDeacquisitionTime <em>Deacquisition Time</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ResourceUsageImpl extends EObjectImpl implements ResourceUsage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright 2007 Thales Research & Technology";

	/**
	 * The cached value of the '{@link #getResource() <em>Resource</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getResource()
	 * @generated
	 * @ordered
	 */
	protected Resource resource = null;

	/**
	 * The default value of the '{@link #getStartTime() <em>Start Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTime()
	 * @generated
	 * @ordered
	 */
	protected static final int START_TIME_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getStartTime() <em>Start Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTime()
	 * @generated
	 * @ordered
	 */
	protected int startTime = START_TIME_EDEFAULT;

	/**
	 * The default value of the '{@link #getEndTime() <em>End Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEndTime()
	 * @generated
	 * @ordered
	 */
	protected static final int END_TIME_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getEndTime() <em>End Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEndTime()
	 * @generated
	 * @ordered
	 */
	protected int endTime = END_TIME_EDEFAULT;

	/**
	 * The default value of the '{@link #getAcquisitionTime() <em>Acquisition Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAcquisitionTime()
	 * @generated
	 * @ordered
	 */
	protected static final int ACQUISITION_TIME_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getAcquisitionTime() <em>Acquisition Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAcquisitionTime()
	 * @generated
	 * @ordered
	 */
	protected int acquisitionTime = ACQUISITION_TIME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDeacquisitionTime() <em>Deacquisition Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeacquisitionTime()
	 * @generated
	 * @ordered
	 */
	protected static final int DEACQUISITION_TIME_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getDeacquisitionTime() <em>Deacquisition Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeacquisitionTime()
	 * @generated
	 * @ordered
	 */
	protected int deacquisitionTime = DEACQUISITION_TIME_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResourceUsageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return TaskPackage.Literals.RESOURCE_USAGE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Resource getResource() {
		if (resource != null && resource.eIsProxy()) {
			InternalEObject oldResource = (InternalEObject)resource;
			resource = (Resource)eResolveProxy(oldResource);
			if (resource != oldResource) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TaskPackage.RESOURCE_USAGE__RESOURCE, oldResource, resource));
			}
		}
		return resource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Resource basicGetResource() {
		return resource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setResource(Resource newResource) {
		Resource oldResource = resource;
		resource = newResource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TaskPackage.RESOURCE_USAGE__RESOURCE, oldResource, resource));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getStartTime() {
		return startTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartTime(int newStartTime) {
		int oldStartTime = startTime;
		startTime = newStartTime;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TaskPackage.RESOURCE_USAGE__START_TIME, oldStartTime, startTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getEndTime() {
		return endTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEndTime(int newEndTime) {
		int oldEndTime = endTime;
		endTime = newEndTime;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TaskPackage.RESOURCE_USAGE__END_TIME, oldEndTime, endTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getAcquisitionTime() {
		return acquisitionTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAcquisitionTime(int newAcquisitionTime) {
		int oldAcquisitionTime = acquisitionTime;
		acquisitionTime = newAcquisitionTime;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TaskPackage.RESOURCE_USAGE__ACQUISITION_TIME, oldAcquisitionTime, acquisitionTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getDeacquisitionTime() {
		return deacquisitionTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeacquisitionTime(int newDeacquisitionTime) {
		int oldDeacquisitionTime = deacquisitionTime;
		deacquisitionTime = newDeacquisitionTime;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TaskPackage.RESOURCE_USAGE__DEACQUISITION_TIME, oldDeacquisitionTime, deacquisitionTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TaskPackage.RESOURCE_USAGE__RESOURCE:
				if (resolve) return getResource();
				return basicGetResource();
			case TaskPackage.RESOURCE_USAGE__START_TIME:
				return new Integer(getStartTime());
			case TaskPackage.RESOURCE_USAGE__END_TIME:
				return new Integer(getEndTime());
			case TaskPackage.RESOURCE_USAGE__ACQUISITION_TIME:
				return new Integer(getAcquisitionTime());
			case TaskPackage.RESOURCE_USAGE__DEACQUISITION_TIME:
				return new Integer(getDeacquisitionTime());
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TaskPackage.RESOURCE_USAGE__RESOURCE:
				setResource((Resource)newValue);
				return;
			case TaskPackage.RESOURCE_USAGE__START_TIME:
				setStartTime(((Integer)newValue).intValue());
				return;
			case TaskPackage.RESOURCE_USAGE__END_TIME:
				setEndTime(((Integer)newValue).intValue());
				return;
			case TaskPackage.RESOURCE_USAGE__ACQUISITION_TIME:
				setAcquisitionTime(((Integer)newValue).intValue());
				return;
			case TaskPackage.RESOURCE_USAGE__DEACQUISITION_TIME:
				setDeacquisitionTime(((Integer)newValue).intValue());
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case TaskPackage.RESOURCE_USAGE__RESOURCE:
				setResource((Resource)null);
				return;
			case TaskPackage.RESOURCE_USAGE__START_TIME:
				setStartTime(START_TIME_EDEFAULT);
				return;
			case TaskPackage.RESOURCE_USAGE__END_TIME:
				setEndTime(END_TIME_EDEFAULT);
				return;
			case TaskPackage.RESOURCE_USAGE__ACQUISITION_TIME:
				setAcquisitionTime(ACQUISITION_TIME_EDEFAULT);
				return;
			case TaskPackage.RESOURCE_USAGE__DEACQUISITION_TIME:
				setDeacquisitionTime(DEACQUISITION_TIME_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TaskPackage.RESOURCE_USAGE__RESOURCE:
				return resource != null;
			case TaskPackage.RESOURCE_USAGE__START_TIME:
				return startTime != START_TIME_EDEFAULT;
			case TaskPackage.RESOURCE_USAGE__END_TIME:
				return endTime != END_TIME_EDEFAULT;
			case TaskPackage.RESOURCE_USAGE__ACQUISITION_TIME:
				return acquisitionTime != ACQUISITION_TIME_EDEFAULT;
			case TaskPackage.RESOURCE_USAGE__DEACQUISITION_TIME:
				return deacquisitionTime != DEACQUISITION_TIME_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (startTime: ");
		result.append(startTime);
		result.append(", endTime: ");
		result.append(endTime);
		result.append(", acquisitionTime: ");
		result.append(acquisitionTime);
		result.append(", deacquisitionTime: ");
		result.append(deacquisitionTime);
		result.append(')');
		return result.toString();
	}

} //ResourceUsageImpl